from twisted.internet.defer import Deferred


class CountDownLatch(object):
    # NOTE For now, we only support successful callbacks, not errbacks
    def __init__(self, count, deferred_list=()):
        self.count = count
        self.completed = Deferred()
        for d in deferred_list:
            self.add(d)

    def add(self, deferred):
        deferred.addCallback(self.count_down)

    def count_down(self, *ignored):
        if self.count > 0:
            self.count -= 1
        if self.count == 0:
            if not self.completed.called:
                self.completed.callback(None) # Maybe collect together these results?
